> ## Documentation Index
> Fetch the complete documentation index at: https://docs.activeviam.com/llms.txt
> Use this file to discover all available pages before exploring further.

# atoti_jdbc.JdbcLoad

### *final class* atoti\_jdbc.JdbcLoad

The definition of a JDBC query.

```pycon theme={"languages":{"custom":["/engine/python-sdk/0.9/languages/pycon.tmLanguage.json"]}}
>>> from atoti_jdbc import JdbcLoad
>>> url = f"h2:{database_path};USER=root;PASSWORD=pass"
>>> jdbc_load = JdbcLoad("SELECT * FROM MYTABLE", url=url)
```

Inferring data types:

```pycon theme={"languages":{"custom":["/engine/python-sdk/0.9/languages/pycon.tmLanguage.json"]}}
>>> data_types = session.tables.infer_data_types(jdbc_load)
>>> data_types
{'ID': 'int', 'CITY': 'String', 'MY_VALUE': 'long'}
```

Creating a table from the inferred data types:

```pycon theme={"languages":{"custom":["/engine/python-sdk/0.9/languages/pycon.tmLanguage.json"]}}
>>> table = session.create_table("Cities", data_types=data_types, keys={"ID"})
```

Loading query results into the table:

```pycon theme={"languages":{"custom":["/engine/python-sdk/0.9/languages/pycon.tmLanguage.json"]}}
>>> table.load(jdbc_load)
>>> table.head().sort_index()
        CITY  MY_VALUE
ID
1      Paris       100
2     London        80
3   New York        90
4     Berlin        70
5    Jakarta        75
```

Using a parametrized query:

```pycon theme={"languages":{"custom":["/engine/python-sdk/0.9/languages/pycon.tmLanguage.json"]}}
>>> table.drop()
>>> table.load(
...     JdbcLoad(
...         "SELECT * FROM MYTABLE WHERE City IN (?, ?)",
...         parameters=["Paris", "New York"],
...         url=url,
...     )
... )
>>> table.head().sort_index()
        CITY  MY_VALUE
ID
1      Paris       100
3   New York        90
```

<Callout icon="link">
  **See also**:
  The other [`DataLoad`](./atoti.data_load.data_load#atoti.data_load.DataLoad) implementations.
</Callout>

#### driver *: Annotated\[[str](https://docs.python.org/3/library/stdtypes.html#str) | [None](https://docs.python.org/3/library/constants.html#None), AfterValidator(\_validate\_driver)]* *= None*

The Java class name of the [`driver`](./atoti_jdbc.driver#module-atoti_jdbc.driver) to use.

This defines Hibernate’s [DRIVER](https://javadoc.io/static/org.hibernate/hibernate-core/5.6.15.Final/org/hibernate/cfg/AvailableSettings.html#DRIVER) option.

Inferred from [`url`](#atoti_jdbc.JdbcLoad.url) if `None`.

#### parameters *: FrozenSequence\[Constant]* *= ()*

The query parameters, sometimes also called *bind variables*.

#### query *: [str](https://docs.python.org/3/library/stdtypes.html#str)*

The query (usually SQL) to execute.

#### url *: Annotated\[[str](https://docs.python.org/3/library/stdtypes.html#str), AfterValidator(normalize\_jdbc\_url)]*

The JDBC connection string of the database.

The `"jdbc"` scheme is optional but the database specific scheme (such as `"h2"`) is mandatory.
For instance:

* `"h2:/home/user/database/file/path;USER=username;PASSWORD=passwd"`
* `"postgresql://postgresql.db.server:5430/example?user=username&password=passwd"`

More examples can be found [here](https://www.baeldung.com/java-jdbc-url-format).

This defines Hibernate’s [URL](https://javadoc.io/static/org.hibernate/hibernate-core/5.6.15.Final/org/hibernate/cfg/AvailableSettings.html#URL) option.
